import automata.FiniteAutomaton;
import cn.ac.ios.automata.words.ContextWord;
import cn.ac.ios.jalf.Statistics;
import cn.ac.ios.learner.fdfa.LearnerFDFA;
import cn.ac.ios.learner.fdfa.tree.LearnerFDFATreePeriodic;
import cn.ac.ios.oracle.Teacher;
import cn.ac.ios.oracle.TeacherRabit;
import cn.ac.ios.query.EquivalenceOracle;
import cn.ac.ios.query.Query;
import cn.ac.ios.translator.Translator;
import cn.ac.ios.translator.TranslatorFDFAOver;
import cn.ac.ios.translator.TranslatorFDFAUnder;
import cn.ac.ios.util.BuechiBuilder;
import cn.ac.ios.util.Timer;
import cn.ac.ios.util.UtilAutomaton;
import cn.ac.ios.value.ContextValue;
import oracle.EqResult;

public class TestROLL {
	public static void main(String []args) {
		String file = "C:/Users/liyong/workspace/jalf/jalf/a-b.ba";
		
		FiniteAutomaton aut = new FiniteAutomaton(file);
		
		Statistics.targetAut = aut;
		
		ContextValue values = new ContextValue();
		ContextWord words= new ContextWord(values);
		
		Teacher<FiniteAutomaton, EqResult, Boolean> teacher = new TeacherRabit(words, aut);
		
		LearnerFDFA learner = new LearnerFDFATreePeriodic(words, teacher);
		
		
		boolean lazyEqCheck = false;
		boolean isUnderApprox = true;
		
		Translator ceTranslator = null;
		
		if(isUnderApprox) {
			ceTranslator = new TranslatorFDFAUnder(learner);
		}else {
			ceTranslator = new TranslatorFDFAOver(learner, teacher);
		}
		
		System.out.println("Start learning...");
		Timer timer = new Timer();
		timer.start();
		learner.startLearning();
		timer.stop();
		Statistics.timeLearner += timer.getTimeElapsed();
		boolean result = false;
		while(! result ) {
			
			FiniteAutomaton hypothesis = BuechiBuilder.build(learner, isUnderApprox);
			Query<EqResult>	query = teacher.answerEquivalenceQuery(hypothesis);

			// get out of the loop
			if(query.getQueryAnswer().isEqual == true) {
				Statistics.setLearnerFDFA(learner);
				Statistics.hypothesis = hypothesis;
				break;
			}
			
			// lazy equivalence check is implemented here
			ceTranslator.setQuery(query);
			while(ceTranslator.canRefine()) {
				Query<Boolean> ceQuery = ceTranslator.translate();
				timer.start();
				learner.refineHypothesis(ceQuery);
				timer.stop();
				Statistics.timeLearner += timer.getTimeElapsed();
				if(! lazyEqCheck) break;
			}

		}
		
		Statistics.print();
	}

}
